#version 330

uniform sampler2D fbo_texture;
uniform sampler2D depth_texture;
uniform sampler2D light_depth_texture;
uniform float offset;
in vec2 f_texcoord;

out vec4 fragColor;

float LinearizeDepth(float zoverw)
{
	float n = 0.1; // You had to change this
	float f = 10000.0; // and this
	
	return(2.0 * n) / (f + n - zoverw * (f - n));	
}

void main(void) 
{
	vec2 texc = f_texcoord;

	float depth = texture2D(depth_texture, texc).r;
	depth = LinearizeDepth(depth)*25;
	depth = clamp(depth,0,1);

	float s = 2.0/800.0;
	vec4 col = texture2D(fbo_texture, texc+vec2(-s,-s))/16;
	col += texture2D(fbo_texture, texc+vec2(s,s))/16;
	col += texture2D(fbo_texture, texc+vec2(-s,s))/16;
	col += texture2D(fbo_texture, texc+vec2(s,-s))/16;

	col += texture2D(fbo_texture, texc+vec2(0,-s))*2/16;
	col += texture2D(fbo_texture, texc+vec2(0,s))*2/16;
	col += texture2D(fbo_texture, texc+vec2(-s,0))*2/16;
	col += texture2D(fbo_texture, texc+vec2(s,0))*2/16;

	col += texture2D(fbo_texture, texc)*4/16;
	vec4 texcol = texture2D(fbo_texture, texc);


	float light_depth = texture2D(light_depth_texture,texc).r;
	fragColor = texcol*(1-depth)+col*(depth);
//	fragColor = vec4(light_depth,light_depth,light_depth,1);
}