#version 430 core

in vec3 position;
in float ttl;
in vec3 velocity;

out vec3 vPosition;
out float vTtl;
out vec3 vVelocity;

uniform float Time;
uniform vec3 emitter_pos;

const float TwoPi = 6.28318530718;
const float InverseMaxInt = 1.0 / 4294967295.0;

float randhashf(uint seed, float b)
{
    uint i=(seed^12345391u)*2654435769u;
    i^=(i<<6u)^(i>>26u);
    i*=2654435769u;
    i+=(i<<5u)^(i>>12u);
    return float(b * i) * InverseMaxInt;
}

void main()
{
    uint seed = uint(Time * 1000.0) + uint(gl_VertexID);

    if(ttl < 0.0)
    {
    	vPosition = emitter_pos;
    	vTtl = randhashf(seed++,10.0);
    	vVelocity = vec3(randhashf(seed++,1)-0.5,randhashf(seed++,0.5),randhashf(seed++,1)-0.5);
    }
    else
    {
    	vPosition = position+velocity*Time;
    	vTtl = ttl - Time;
        vVelocity.x = velocity.x*(1-0.1*Time);
        vVelocity.z = velocity.z*(1-0.1*Time);
        vVelocity.y = velocity.y*(1+0.1*Time);
    }    
}
